'use strict'
const path = require('path')
const defaultSettings = require('./src/settings.js')

function resolve(dir) {
  return path.join(__dirname, dir)
}

const name = defaultSettings.title || '' // page title

// If your port is set to 80,
// use administrator privileges to execute the command line.
// For example, Mac: sudo npm run
// You can change the port by the following methods:
// port = 9528 npm run dev OR npm run dev --port = 9528
const port = process.env.port || process.env.npm_config_port || 9528 // dev port

// All configuration item explanations can be find in https://cli.vuejs.org/config/
module.exports = {
  /**
   * You will need to set publicPath if you plan to deploy your site under a sub path,
   * for example GitHub Pages. If you plan to deploy your site to https://foo.github.io/bar/,
   * then publicPath should be set to "/bar/".
   * In most cases please use '/' !!!
   * Detail: https://cli.vuejs.org/config/#publicpath
   */
  publicPath: './',
  outputDir: 'dist',
  assetsDir: 'static',
  lintOnSave: process.env.NODE_ENV === 'development',
  productionSourceMap: false,
  devServer: {
    port: port,
    open: true,
    overlay: {
      warnings: false,
      errors: true
    },
    proxy: {
      '/dev-api': {
        // 此处的写法，目的是为了 将 /api 替换成 https://www.baidu.com/
        // target: 'http://ca.midsk.cn:8080',
        target: 'http://106.14.243.117:8080',
        // target: '10.211.66.25:8074',
        // target: 'http://192.168.3.67:8092',
        // target: 'http://10.9.247.105:8092',
        // target: 'http://127.0.0.1:4523/mock/528199',
        // 允许跨域
        changeOrigin: true,
        ws: true,
        pathRewrite: {
          ['^' + '/dev-api']: ''
        }
      }
    }
    // before: require('./mock/mock-server.js')
  },

}
